module Rubapi
  class Server < EM::Connection
    include EM::HttpServer

    class << self
      attr_accessor :rest_routes

      def route_with(routes)
        self.rest_routes = routes
      end
    end

    def build_params
      Request.new.tap do |r|
        r.parse(@http_query_string)
        r.parse(@http_post_content)
      end
    end

    def process_http_request

      controller = Controller.new(EM::DelegatedHttpResponse.new(self))
      controller.request = build_params 
      controller.run Server.rest_routes.fetch(@http_request_uri, @http_request_method.downcase.to_sym)
    end
  end
end
